/* 
 *    Skapat av Markus Jakobsoson 
      Automatiserar.se 

      Syftet är att få en mode sensor som kommunicerar över blåtand.

    
     H(ome)    = Grön = 12
     A(way)    = RÖD  = 11
     N(ight)   = Blå  = 10
     V(acation = Gul  = 9
     D(emo)    = mönster på arduinon.
*/ 

char myBluetoothvalue;       // bluetooth värdet
char lastValue;              // senaste värdet kan nu vara: (H,A,N,V,D)
char beforeD;                // värdet som kom före "D"
int  demoLight = 200;        // hur lång delay i ms i rinnande ljus
void setup() {
  // put your setup code here, to run once:

 Serial.begin(9600); 

 pinMode(13,OUTPUT); // led på kortet som lyser om man skickar fel tecken.
 pinMode(12,OUTPUT); // Grön 
 pinMode(11,OUTPUT); // Röd
 pinMode(10,OUTPUT); // Blå
 pinMode(9,OUTPUT);  // Gul
}

// börja köra loopen
void loop() {

  if(Serial.available())
  {//if there is data being recieved
    myBluetoothvalue=Serial.read(); //read it
  }

   checkBluetoothValue(); 
   delay(1000); 
}

// följande funktion kontrollerar senaste värdet som mottogs. 
void checkBluetoothValue(){

  if (myBluetoothvalue=='H')
  {
    if (lastValue!='H'){

    setAllOff(); // släck alla dioder.
    Serial.println(F("HOME"));
    setAllOff(); // släck alla dioder.
    setLedStatus(12); // startar home
    lastValue=myBluetoothvalue;
    }
    
  }
  else if (myBluetoothvalue=='A')
  {
    if (lastValue!='A'){

    Serial.println(F("AWAY"));
    setAllOff(); // släck alla dioder.
    setLedStatus(11); // startar AWAY
    lastValue=myBluetoothvalue;
    }
  }
  else if (myBluetoothvalue=='N')
  {
    
    if (lastValue!='N'){

    Serial.println(F("NIGHT MODE"));
    setAllOff(); // släck alla dioder.
    setLedStatus(10); // startar NIGHT
    lastValue=myBluetoothvalue;
    }
  }
   else if (myBluetoothvalue=='V')
  {
    
    if (lastValue!='V'){

    Serial.println(F("VACATION MODE"));
    setAllOff(); // släck alla dioder.
    setLedStatus(9); // startar VACAION
    lastValue=myBluetoothvalue;
    }
  }
  else if (myBluetoothvalue=='D')
  {
    
    if (lastValue!='D'){

    Serial.println(F("DEMO MODE!"));
    setAllOff(); // släck alla dioder.
    showdemo(); // kör nått styggt med alla dioder.
    lastValue=myBluetoothvalue;
    }
  }
  else {
      setAllOff(); // felande värde motttogs släcker allt..
      void startErrorLed(); // tänder fel ledden.
  }

} // end checkBlueToothVal


void setAllOff(){

   digitalWrite(13,LOW);
   digitalWrite(12,LOW);
   digitalWrite(11,LOW);
   digitalWrite(10,LOW);
   digitalWrite(9,LOW);
   
}

void startErrorLed(){

    digitalWrite(13,HIGH);
}

void setLedStatus(int LedtoStart){


   digitalWrite(LedtoStart, HIGH); // tänder aktuell LED.
}


// om D mottags så körs detta.
void showdemo() {

   
   digitalWrite(12,HIGH);
   delay(demoLight);
   digitalWrite(11,HIGH);
   delay(demoLight);
   digitalWrite(10,HIGH);
   delay(demoLight);
   digitalWrite(9,HIGH);
   delay(demoLight);
   digitalWrite(12,LOW);
   delay(demoLight);
   digitalWrite(11,LOW);
   delay(demoLight);
   digitalWrite(10,LOW);
   delay(demoLight);
   digitalWrite(9,LOW);
   delay(demoLight);
   digitalWrite(12,HIGH);
   delay(demoLight);
   digitalWrite(11,HIGH);
   delay(demoLight);
   digitalWrite(10,HIGH);
   delay(demoLight);
   digitalWrite(9,HIGH);
   delay(demoLight);
   digitalWrite(12,LOW);
   delay(demoLight);
   digitalWrite(11,LOW);
   delay(demoLight);
   digitalWrite(10,LOW);
   delay(demoLight);
   digitalWrite(9,LOW);

   setAllOff(); 
}


